----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    13:46:28 10/10/2007 
-- Design Name: 
-- Module Name:    Speed_Cnt2 - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity Speed_Cnt2 is
    Port ( Clk : 	     in  STD_LOGIC;
           Btn_Up :    in  STD_LOGIC;
           Btn_Down :  in  STD_LOGIC;
           Btn_Reset : in  STD_LOGIC;
           Led :      out  STD_LOGIC_VECTOR (5 downto 0));
end Speed_Cnt2;

architecture Behavioral of Speed_Cnt2 is
   Signal Speed:    STD_LOGIC_VECTOR (5 downto 0):= "000000";
	Signal BtnUp:	  STD_LOGIC_VECTOR (2 downto 0);
	Signal BtnDown:  STD_LOGIC_VECTOR (2 downto 0);
	Signal BtnRes:   STD_LOGIC_VECTOR (2 downto 0);	
begin
	--###########################################################
   -- Three 3-bit shiftregisters for edge-detection
	process(Clk)
	begin
		if Rising_edge( Clk) then
			BtnUp   <= BtnUp  (1 downto 0) & Btn_Up;
			BtnDown <= BtnDown(1 downto 0) & Btn_Down;
			BtnRes  <= BtnRes (1 downto 0) & Btn_Reset;
		end if;
	end process;

	--###########################################################	
   process(Clk)
	begin
	   if Rising_Edge(Clk) then
		   if BtnUp="011" then
			   Speed <= Speed + "100";
			end if;
		   if BtnDown="011" then
			   Speed <= Speed - "1";
			end if;
		   if BtnRes="011" then
			   Speed <= (others => '0');
			end if;
		end if;
	end process;
	
	Led <= Speed;
end Behavioral;

