----------------------------------------------------------------------------------
-- Company: MMMI - SDU
-- Engineer: JJM
-- 
-- Create Date:    15:24:22 10/10/2007 
-- Design Name: 
-- Module Name:    Speed_Cnt3b - Behavioral 
-- Project Name: 
-- Target Devices: Any
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
-- 
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity Speed_Cnt3b is
    Port ( Clk : 	     in  STD_LOGIC;
           Btn_Up :    in  STD_LOGIC;
           Btn_Down :  in  STD_LOGIC;
           Btn_Reset : in  STD_LOGIC;
           Led :      out  STD_LOGIC_VECTOR (5 downto 0));
end Speed_Cnt3b;

architecture Behavioral of Speed_Cnt3b is
   Signal Speed:   STD_LOGIC_VECTOR (5 downto 0);--:= "000000";
	Signal CClk,En: STD_LOGIC;	
begin	
   --###########################################################
   -- Remember the last value of CClk
   process( Clk)
	begin
	   if Rising_Edge(Clk) then
	      CClk <= Btn_Up or Btn_Down or Btn_Reset;
		end if;
	end process;
	
	--###########################################################
	-- En = 1 when an edge been detected
	En <= not CClk and (Btn_Up or Btn_Down or Btn_Reset);
	
	--###########################################################
   process(Clk)
	begin
	   if Rising_Edge(Clk) then
		   if En='1' then
				if Btn_Up='1' then
					Speed <= Speed + "100";
				end if;
				if Btn_Down='1' then
					Speed <= Speed - "1";
				end if;
				if Btn_Reset='1' then
					Speed <= (others => '0');
				end if;
			end if;
		end if;
	end process;
	
	Led <= Speed;
end Behavioral;

